<template>
  <div>
    <create
      :is-active="isAddCollectionDialogActive"
      @close="isAddCollectionDialogActive = false"
      @created="onCollectionCreated"
    />
    <div
      class="flex items-center"
    >
      <q-btn
        color="green"
        icon="add"
        round
        @click="isAddCollectionDialogActive = true"
      />
      <div class="q-ml-md">
        <div
          class="flex items-center"
          v-if="isLoadingCollections"
        >
          <q-spinner name="mat" size="32px"/>
          <span class="q-ml-sm">Loading collections...</span>
        </div>
        <q-select
          v-else
          v-model="selectedCollection"
          stack-label="Collection"
          :options="availableCollections"
          filter
          color="white"
          inverted-light
        />
      </div>
    </div>
    <div class="flex items-center q-mt-md">
      <collection :id="selectedCollection"/>
    </div>
  </div>
</template>

<script>
    import apiMixin from '../../../../mixins/apiMixin';
    import Create from './forms/create';
    import Collection from './forms/collection';
    import endpointsMixin from '../../../../mixins/endpointsMixin';

    export default {
      name: 'collectionsConfigurator',
      components: { Collection, Create },
      mixins: [apiMixin, endpointsMixin],
      created() {
        this.loadCollections();
      },
      data() {
        return {
          selectedCollection: null,
          availableCollections: null,

          isLoadingCollections: false,

          isAddCollectionDialogActive: false,
        };
      },
      methods: {
        onCollectionCreated(id) {
          this.loadCollections()
            .then(() => {
              this.$nextTick(() => {
                this.selectedCollection = id;
              });
            });
        },
        loadCollections() {
          this.isLoadingCollections = true;

          return new Promise((resolve) => {
            this.fetchCollections()
              .then((results) => {
                this.availableCollections = results/* .filter(({ collection_id: id }) => (
                  id.indexOf('test_') > -1
                )) */.map(
                  ({ collection_id: id }) => ({
                    label: id,
                    value: id,
                  }),
                );
                resolve();
                this.isLoadingCollections = false;
              })
              .catch(() => {
                this.isLoadingCollections = false;
              });
          });
        },
      },
    };
</script>
